package se.nekotronic.androidbouncer;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.Socket;

public class ClientTalkerThread extends Thread {
	BouncerActivity parent;
	private Socket socket;
	private BufferedReader from_client;
	private PrintWriter to_client;
	private static int instances = 0;
	private int number = ++instances;
	private boolean quit = false;

	public ClientTalkerThread(BouncerActivity parent, Socket socket, BufferedReader from_client, PrintWriter to_client) {
		this.parent = parent;
		this.socket = socket;
		this.from_client = from_client;
		this.to_client = to_client;
	}

	public void please_stop() {
		quit = true;
		try {
			to_client.flush();
			socket.shutdownInput();
		} catch (IOException e) {
			// Couldn't close. Not much we can do.
			parent.print("Problem closing connection " + number);
		}
	}

	public void run() {
		try { 
			while (! quit) {
				String line_from_client;
				line_from_client = from_client.readLine();
				parent.print("From client " + number + ": " + line_from_client);
				if (line_from_client == null) {
					parent.print("Client thread " + number + " got null from readLine. Finishing thread.");
					quit = true;
				}
				else if (line_from_client.equals("PING")) {
					send("PONG");
				}
				else if (line_from_client.equals("BYE")) {
					parent.print("Client thread " + number + " got BYE from readLine. Finishing thread.");
					send("BYE");
					quit = true;
				}
				else {
					send("ERROR");
				}
			} // while
			to_client.close();
			from_client.close();
			socket.close();
			// parent.done();
		}
		catch (IOException e) {
			parent.print("Client thread " + number + " got an IOException: " + e);
			e.printStackTrace();
			quit = true;
		}
		parent.client_has_disconneted(this);
	} // run

	public void send(String line) {
		to_client.println(line);
	}
} // ClientTalkerThread
